﻿/* 
 * app v1.1 
 * 应用辅助处理，部分方法同时支持Web、App，方便Web调试。
 */
var app = {
    ver: 1.1,
	headPos:{},	//标题栏的宽、高
	bodyPos:{},	//主体内容的宽、高
	keyBackCount: 0,   //按返回键的次数
	
	isApp: function(){ return typeof api=="object"; },
	
	//页面加载成功后初始化
	load: function(cfg){
        this.loadPos();
		if(cfg==null) cfg = {}; 
		if(cfg.keyback!=false){ 
			//返回键事件
			api.addEventListener({name: 'keyback'}, function(ret, err){
	            api.closeWin(); 
	        });
        }
        var header = $api.byId('header');
        if(header){
            //修正顶部栏
            $api.fixStatusBar(header);
            $api.fixIos7Bar(header);
            this.loadPos();
        }
        var code = this.data("AgentServerCode");
        if(code) eval(code);
        return this;
	},
	//按两次返回键退出
	keyBackTwo: function(){
        api.addEventListener({name: 'keyback'}, function(ret, err){
            app.keyBackCount += 1;
            setTimeout(function(){ app.keyBackCount=0; },3000);
            if(app.keyBackCount>1) api.closeWin({name:"root"});
            if(app.keyBackCount==1) app.toast("再按一次退出应用");
        });   
	},
	
	//加载位置信息
	loadPos: function(){
        var header = $api.byId('header') || $api.dom(document,'header'), body = $api.dom('body');
	    //保存标题位置信息
        if(header) this.headPos = $api.offset(header);
        //保存主体位置信息 
        if(body) this.bodyPos = $api.offset(body);
	},
	
	//加载内容框架，把页面名称中的_win改成_frm。
	loadFrm: function(name, url){
		if(name==null && url==null){
			name = this.pageName(); 
			name = url = name.replace((name.indexOf('_win.')? '_win.':'.'),'_frm.');
		}else if(name && url==null){
			url = name;
		}
		api.openFrame({
            name: name,
            url: url,
            bounces: true,
            rect: {
                x: 0,
                y: app.headPos.h || 0,
                w: app.headPos.w || 'auto',
                h: 'auto'
            },
            reload: true,
            pageParam: api.pageParam    //传递参数给frame
        });
        return this;	
	},
	
	//打开窗口(名称、地址，参数[JSON])
	open: function(name, url, param){
		if(url==null){
			url=name;
			name=url.split("?")[0];
		}
		api.openWin({name:name,url:url,opaque:false,bgColor:'#FFF',reload:true,delay:1000,pageParam:param});
		return this;
	},
	//关闭窗口
	close: function(name){
        if(name) return api.closeWin({name: name});
		api.closeWin();
	},
	//关闭到指定窗口
    closeToWin: function(name){
        api.closeToWin({name: name});
    },
	//打开侧滑菜单
	openSlide: function(){ api.openSlidPane({type:'left'}); },
	
	back: function(){ api.historyBack() },
	
	//取当前页面名称(带后缀名)
    pageName: function(){
		 var strUrl=location.href, arrUrl=strUrl.split("/");
		 return arrUrl[arrUrl.length-1];
    },
    
    //执行脚本
    eval: function(name, frm, code){
    	if(code==null){
    		code = frm;
    		frm ='';
    	}
    	api.execScript({name:name, frameName:frm, script:code });	
	},
	
	//显示提示（消息文本，延时秒数）
	toast: function(msg, delay){
		if(!this.isApp()) return alert(msg);
		api.toast({
            msg: msg,
            duration: delay || 2000,
            location: 'bottom'
        });
	},
	
	//显示加载提示
	showLoad: function(title, delay){
		api.showProgress({
            style: 'default',
            animationType: 'fade',
            title: title || '',text: '',
            modal: false
        });
        setTimeout(function(){
            api.hideProgress();
        },delay || 1000);
	},
	hideLoad: function(){ if(this.isApp()) api.hideProgress(); },
	
	formatDate: function(dateStr){
       var arr = dateStr.split("-");
       if(arr[1].length==1) arr[1]="0"+arr[1];
       if(arr[2].length==1) arr[2]="0"+arr[2];
       return arr.join("-");
    },
    selectDate: function (id){
       this.loadPos();
       api.openFrame({
            name: "selectDate",
            url: "selectDate.html",
            rect: {
                x: 0,
                y: api.winHeight - 200,
                w: 'auto',
                h: 200 
            },
            reload: true,
            pageParam: {id:id, winName:api.winName, frameName:api.frameName}
        });     
    },
    setSelectDate: function(id,str){ 
        $api.byId(id).value=str; 
    },
    //本地数据操作，传val设置值，不传val返回值。
    data: function(key,val){
        if(window.localStorage){
            if(val!=null) localStorage.setItem(key,val);
            val = localStorage.getItem(key);
            return val==null? '':val;    
        }else{
            alert("错误：不支持存储数据！");
        }
    }
};